<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.5"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>DayZExpansion: DayzExpansion/Book/Scripts/4_world/dayzexpansion_book/classes/recipes/recipebase.c Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="../../doxygen_light.png"/></td>
  <td id="projectalign">
   <div id="projectname">DayZExpansion<span id="projectnumber">&#160;1.7.12</span>
   </div>
   <div id="projectbrief">DayZExpansion Script Documentation Courtecy of P4K1TZ</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.5 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "../../search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="../../menudata.js"></script>
<script type="text/javascript" src="../../menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('../../',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(document).ready(function(){initNavTree('d8/df0/a00557_source.html','../../'); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div class="header">
  <div class="headertitle"><div class="title">recipebase.c</div></div>
</div><!--header-->
<div class="contents">
<a href="../../d8/df0/a00557.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/**</span></div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment"> * RecipeBase.c</span></div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment"> *</span></div>
<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment"> * DayZ Expansion Mod</span></div>
<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="comment"> * www.dayzexpansion.com</span></div>
<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span><span class="comment"> * © 2022 DayZ Expansion Mod Team</span></div>
<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span><span class="comment"> *</span></div>
<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span><span class="comment"> * This work is licensed under the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International License.</span></div>
<div class="line"><a id="l00009" name="l00009"></a><span class="lineno">    9</span><span class="comment"> * To view a copy of this license, visit http://creativecommons.org/licenses/by-nc-nd/4.0/.</span></div>
<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span><span class="comment"> *</span></div>
<div class="line"><a id="l00011" name="l00011"></a><span class="lineno">   11</span><span class="comment">*/</span></div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span> </div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span>modded <span class="keyword">class </span><a class="code hl_class" href="../../d3/d95/a01435.html">RecipeBase</a></div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span>{</div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno"><a class="line" href="../../d3/d95/a01435.html#adfe87c476a9ca142c120bc1af7ea1dbf">   15</a></span>    <span class="keyword">protected</span> <span class="keyword">static</span> ref map&lt;string, string&gt; <a class="code hl_variable" href="../../d3/d95/a01435.html#adfe87c476a9ca142c120bc1af7ea1dbf">m_Expansion_TypeDisplayNames</a>;</div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span> </div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno"><a class="line" href="../../d3/d95/a01435.html#a83472400848cd2193dc62a96249aa7bb">   17</a></span>    array&lt;ref array&lt;ref ExpansionBookCraftingItem&gt;&gt; <a class="code hl_function" href="../../d3/d95/a01435.html#a83472400848cd2193dc62a96249aa7bb">ExpansionGetIngredients</a>()</div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span>    {</div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span>        array&lt;ref array&lt;ref ExpansionBookCraftingItem&gt;&gt; allIngredients = <span class="keyword">new</span> array&lt;ref array&lt;ref ExpansionBookCraftingItem&gt;&gt;;</div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span> </div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span>        <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i &lt; MAX_NUMBER_OF_INGREDIENTS; i++)</div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span>        {</div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span>            map&lt;string, ref ExpansionBookCraftingItem&gt; tmp = <span class="keyword">new</span> map&lt;string, ref ExpansionBookCraftingItem&gt;;</div>
<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span>            map&lt;string, ref array&lt;string&gt;&gt; displayNamesTypes = <span class="keyword">new</span> map&lt;string, ref array&lt;string&gt;&gt;;</div>
<div class="line"><a id="l00025" name="l00025"></a><span class="lineno">   25</span> </div>
<div class="line"><a id="l00026" name="l00026"></a><span class="lineno">   26</span>            <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j = 0; j &lt; m_Ingredients[i].Count(); j++)</div>
<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span>            {</div>
<div class="line"><a id="l00028" name="l00028"></a><span class="lineno">   28</span>                <span class="keywordtype">string</span> className = m_Ingredients[i][j];</div>
<div class="line"><a id="l00029" name="l00029"></a><span class="lineno">   29</span> </div>
<div class="line"><a id="l00030" name="l00030"></a><span class="lineno">   30</span>                <span class="keywordflow">if</span> (!<a class="code hl_class" href="../../db/d6d/a02239.html">ExpansionStatic</a>.<a class="code hl_function" href="../../db/d6d/a02239.html#af02af7eca0824d4329ade05587d8a9ac">ItemExists</a>(className))</div>
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno">   31</span>                    <span class="keywordflow">continue</span>;</div>
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno">   32</span> </div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span>                <span class="keywordtype">string</span> displayName = <span class="stringliteral">&quot;&quot;</span>;</div>
<div class="line"><a id="l00034" name="l00034"></a><span class="lineno">   34</span> </div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno">   35</span>                <span class="keywordtype">bool</span> updateAmount = <span class="keyword">true</span>;</div>
<div class="line"><a id="l00036" name="l00036"></a><span class="lineno">   36</span><span class="comment"></span> </div>
<div class="line"><a id="l00037" name="l00037"></a><span class="lineno">   37</span><span class="comment">                //! Hmm. This is still a bit iffy but should work ok for now</span></div>
<div class="line"><a id="l00038" name="l00038"></a><span class="lineno">   38</span><span class="comment"></span>                array&lt;string&gt; itemInfo = <span class="keyword">new</span> array&lt;string&gt;;</div>
<div class="line"><a id="l00039" name="l00039"></a><span class="lineno">   39</span>                GetGame().ConfigGetTextArray(<span class="stringliteral">&quot;CfgVehicles &quot;</span> + className + <span class="stringliteral">&quot; itemInfo&quot;</span>, itemInfo);</div>
<div class="line"><a id="l00040" name="l00040"></a><span class="lineno">   40</span>                <span class="keywordtype">bool</span> isBaseballBat = <span class="keyword">false</span>;</div>
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno">   41</span>                <span class="keywordtype">bool</span> isKnife = <span class="keyword">false</span>;</div>
<div class="line"><a id="l00042" name="l00042"></a><span class="lineno">   42</span>                <span class="keywordtype">bool</span> isAxe = <span class="keyword">false</span>;</div>
<div class="line"><a id="l00043" name="l00043"></a><span class="lineno">   43</span>                <span class="keywordtype">bool</span> isBayonet = <span class="keyword">false</span>;</div>
<div class="line"><a id="l00044" name="l00044"></a><span class="lineno">   44</span>                <span class="keywordtype">bool</span> isSaw = <span class="keyword">false</span>;</div>
<div class="line"><a id="l00045" name="l00045"></a><span class="lineno">   45</span>                <span class="keywordflow">if</span> (className == <span class="stringliteral">&quot;Hacksaw&quot;</span> || className == <span class="stringliteral">&quot;HandSaw&quot;</span>)</div>
<div class="line"><a id="l00046" name="l00046"></a><span class="lineno">   46</span>                    isSaw = <span class="keyword">true</span>;</div>
<div class="line"><a id="l00047" name="l00047"></a><span class="lineno">   47</span>                <span class="keywordflow">else</span> <span class="keywordflow">if</span> (className.Contains(<span class="stringliteral">&quot;BaseballBat&quot;</span>))</div>
<div class="line"><a id="l00048" name="l00048"></a><span class="lineno">   48</span>                    isBaseballBat = <span class="keyword">true</span>;</div>
<div class="line"><a id="l00049" name="l00049"></a><span class="lineno">   49</span>                <span class="keywordflow">else</span> <span class="keywordflow">if</span> (className.Contains(<span class="stringliteral">&quot;Knife&quot;</span>) &amp;&amp; itemInfo.Find(<span class="stringliteral">&quot;Knife&quot;</span>) &gt; -1)</div>
<div class="line"><a id="l00050" name="l00050"></a><span class="lineno">   50</span>                    isKnife = <span class="keyword">true</span>;</div>
<div class="line"><a id="l00051" name="l00051"></a><span class="lineno">   51</span>                <span class="keywordflow">else</span> <span class="keywordflow">if</span> (className.Contains(<span class="stringliteral">&quot;Axe&quot;</span>) &amp;&amp; itemInfo.Find(<span class="stringliteral">&quot;Axe&quot;</span>) &gt; -1)</div>
<div class="line"><a id="l00052" name="l00052"></a><span class="lineno">   52</span>                    isAxe = <span class="keyword">true</span>;</div>
<div class="line"><a id="l00053" name="l00053"></a><span class="lineno">   53</span>                <span class="keywordflow">else</span> <span class="keywordflow">if</span> (className.Contains(<span class="stringliteral">&quot;Bayonet&quot;</span>) &amp;&amp; itemInfo.Find(<span class="stringliteral">&quot;Knife&quot;</span>) &gt; -1)</div>
<div class="line"><a id="l00054" name="l00054"></a><span class="lineno">   54</span>                    isBayonet = <span class="keyword">true</span>;</div>
<div class="line"><a id="l00055" name="l00055"></a><span class="lineno">   55</span>                <span class="keywordflow">if</span> (isBaseballBat || isKnife || isAxe || isBayonet || isSaw)</div>
<div class="line"><a id="l00056" name="l00056"></a><span class="lineno">   56</span>                {<span class="comment"></span></div>
<div class="line"><a id="l00057" name="l00057"></a><span class="lineno">   57</span><span class="comment">                    //! Don&#39;t show all the different types, just show a generic &quot;Knife&quot;, &quot;Axe&quot;, &quot;Bayonet&quot; or &quot;Baseball Bat&quot;</span></div>
<div class="line"><a id="l00058" name="l00058"></a><span class="lineno">   58</span><span class="comment"></span>                    <span class="keywordflow">if</span> (isKnife)</div>
<div class="line"><a id="l00059" name="l00059"></a><span class="lineno">   59</span>                        displayName = <span class="stringliteral">&quot;#STR_EXPANSION_GENERIC_KNIFE&quot;</span>;</div>
<div class="line"><a id="l00060" name="l00060"></a><span class="lineno">   60</span>                    <span class="keywordflow">else</span> <span class="keywordflow">if</span> (isAxe)</div>
<div class="line"><a id="l00061" name="l00061"></a><span class="lineno">   61</span>                        displayName = <span class="stringliteral">&quot;#STR_EXPANSION_GENERIC_AXE&quot;</span>;</div>
<div class="line"><a id="l00062" name="l00062"></a><span class="lineno">   62</span>                    <span class="keywordflow">else</span> <span class="keywordflow">if</span> (isBayonet)</div>
<div class="line"><a id="l00063" name="l00063"></a><span class="lineno">   63</span>                        displayName = <span class="stringliteral">&quot;#STR_EXPANSION_GENERIC_BAYONET&quot;</span>;</div>
<div class="line"><a id="l00064" name="l00064"></a><span class="lineno">   64</span>                    <span class="keywordflow">else</span> <span class="keywordflow">if</span> (isSaw)</div>
<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span>                        displayName = <span class="stringliteral">&quot;#STR_EXPANSION_GENERIC_SAW&quot;</span>;</div>
<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span>                    <span class="keywordflow">else</span></div>
<div class="line"><a id="l00067" name="l00067"></a><span class="lineno">   67</span>                        displayName = <span class="stringliteral">&quot;#str_cfgvehicles_baseballbat0&quot;</span>;</div>
<div class="line"><a id="l00068" name="l00068"></a><span class="lineno">   68</span> </div>
<div class="line"><a id="l00069" name="l00069"></a><span class="lineno">   69</span>                    updateAmount = <span class="keyword">false</span>;</div>
<div class="line"><a id="l00070" name="l00070"></a><span class="lineno">   70</span>                }</div>
<div class="line"><a id="l00071" name="l00071"></a><span class="lineno">   71</span>                <span class="keywordflow">else</span></div>
<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span>                {</div>
<div class="line"><a id="l00073" name="l00073"></a><span class="lineno">   73</span>                    displayName = <a class="code hl_class" href="../../db/d6d/a02239.html">ExpansionStatic</a>.<a class="code hl_function" href="../../db/d6d/a02239.html#aafd3d34ac394eb9251cf7ec9a4f3678f">GetItemDisplayNameWithType</a>(className, <a class="code hl_variable" href="../../d3/d95/a01435.html#adfe87c476a9ca142c120bc1af7ea1dbf">m_Expansion_TypeDisplayNames</a>);</div>
<div class="line"><a id="l00074" name="l00074"></a><span class="lineno">   74</span>                    <span class="comment"></span></div>
<div class="line"><a id="l00075" name="l00075"></a><span class="lineno">   75</span><span class="comment">                    //! Deal with the case where several different class names have the same display name</span></div>
<div class="line"><a id="l00076" name="l00076"></a><span class="lineno">   76</span><span class="comment"></span>                    array&lt;string&gt; displayNameTypes;</div>
<div class="line"><a id="l00077" name="l00077"></a><span class="lineno">   77</span>                    <span class="keywordflow">if</span> (displayNamesTypes.Find(displayName, displayNameTypes))</div>
<div class="line"><a id="l00078" name="l00078"></a><span class="lineno">   78</span>                    {</div>
<div class="line"><a id="l00079" name="l00079"></a><span class="lineno">   79</span>                        updateAmount = displayNameTypes.Find(className) &gt; -1;</div>
<div class="line"><a id="l00080" name="l00080"></a><span class="lineno">   80</span>                    }</div>
<div class="line"><a id="l00081" name="l00081"></a><span class="lineno">   81</span>                    <span class="keywordflow">else</span></div>
<div class="line"><a id="l00082" name="l00082"></a><span class="lineno">   82</span>                    {</div>
<div class="line"><a id="l00083" name="l00083"></a><span class="lineno">   83</span>                        displayNameTypes = <span class="keyword">new</span> array&lt;string&gt;;</div>
<div class="line"><a id="l00084" name="l00084"></a><span class="lineno">   84</span>                        displayNamesTypes.Insert(displayName, displayNameTypes);</div>
<div class="line"><a id="l00085" name="l00085"></a><span class="lineno">   85</span>                    }</div>
<div class="line"><a id="l00086" name="l00086"></a><span class="lineno">   86</span>                    displayNameTypes.Insert(className);</div>
<div class="line"><a id="l00087" name="l00087"></a><span class="lineno">   87</span>                }</div>
<div class="line"><a id="l00088" name="l00088"></a><span class="lineno">   88</span> </div>
<div class="line"><a id="l00089" name="l00089"></a><span class="lineno">   89</span>                <span class="keywordflow">if</span> (!displayName || displayName.IndexOf(<span class="stringliteral">&quot;$UNT$&quot;</span>) == 0)  <span class="comment">//! Skip not ready items</span></div>
<div class="line"><a id="l00090" name="l00090"></a><span class="lineno">   90</span>                    <span class="keywordflow">continue</span>;</div>
<div class="line"><a id="l00091" name="l00091"></a><span class="lineno">   91</span> </div>
<div class="line"><a id="l00092" name="l00092"></a><span class="lineno">   92</span>                <span class="keywordtype">int</span> amount = <a class="code hl_function" href="../../d3/d95/a01435.html#a6294384bb75e994c9ed0b40a54efc58b">ExpansionGetAmount</a>(className, m_MinQuantityIngredient[i]);</div>
<div class="line"><a id="l00093" name="l00093"></a><span class="lineno">   93</span> </div>
<div class="line"><a id="l00094" name="l00094"></a><span class="lineno">   94</span>                <a class="code hl_class" href="../../d6/d19/a01947.html">ExpansionBookCraftingItem</a> ingredient;</div>
<div class="line"><a id="l00095" name="l00095"></a><span class="lineno">   95</span>                <span class="keywordflow">if</span> (tmp.Find(displayName, ingredient))</div>
<div class="line"><a id="l00096" name="l00096"></a><span class="lineno">   96</span>                {</div>
<div class="line"><a id="l00097" name="l00097"></a><span class="lineno">   97</span>                    <span class="keywordflow">if</span> (updateAmount)</div>
<div class="line"><a id="l00098" name="l00098"></a><span class="lineno">   98</span>                        ingredient.<a class="code hl_variable" href="../../d6/d19/a01947.html#a49d2f2548f5949de27af139d4860fc05">Amount</a> += amount;</div>
<div class="line"><a id="l00099" name="l00099"></a><span class="lineno">   99</span>                }</div>
<div class="line"><a id="l00100" name="l00100"></a><span class="lineno">  100</span>                <span class="keywordflow">else</span></div>
<div class="line"><a id="l00101" name="l00101"></a><span class="lineno">  101</span>                {</div>
<div class="line"><a id="l00102" name="l00102"></a><span class="lineno">  102</span>                    ingredient = <span class="keyword">new</span> <a class="code hl_class" href="../../d6/d19/a01947.html">ExpansionBookCraftingItem</a>(displayName, amount);</div>
<div class="line"><a id="l00103" name="l00103"></a><span class="lineno">  103</span>                    tmp.Insert(displayName, ingredient);</div>
<div class="line"><a id="l00104" name="l00104"></a><span class="lineno">  104</span>                }</div>
<div class="line"><a id="l00105" name="l00105"></a><span class="lineno">  105</span>                ingredient.<a class="code hl_variable" href="../../d6/d19/a01947.html#ac13cf4ea0ed9041d9736b3834120e570">ClassNames</a>.Insert(className);</div>
<div class="line"><a id="l00106" name="l00106"></a><span class="lineno">  106</span>            }</div>
<div class="line"><a id="l00107" name="l00107"></a><span class="lineno">  107</span> </div>
<div class="line"><a id="l00108" name="l00108"></a><span class="lineno">  108</span>            allIngredients.Insert(<a class="code hl_function" href="../../d3/d95/a01435.html#a4a2f2889d8052e61d6ea0a3ccf0c10b3">ExpansionGetItems</a>(tmp));</div>
<div class="line"><a id="l00109" name="l00109"></a><span class="lineno">  109</span>        }</div>
<div class="line"><a id="l00110" name="l00110"></a><span class="lineno">  110</span> </div>
<div class="line"><a id="l00111" name="l00111"></a><span class="lineno">  111</span>        <span class="keywordflow">return</span> allIngredients;</div>
<div class="line"><a id="l00112" name="l00112"></a><span class="lineno">  112</span>    }</div>
<div class="line"><a id="l00113" name="l00113"></a><span class="lineno">  113</span> </div>
<div class="line"><a id="l00114" name="l00114"></a><span class="lineno"><a class="line" href="../../d3/d95/a01435.html#a8c2b9eb21d7207f1880b4b9f8e10b1d0">  114</a></span>    array&lt;ref ExpansionBookCraftingItem&gt; <a class="code hl_function" href="../../d3/d95/a01435.html#a8c2b9eb21d7207f1880b4b9f8e10b1d0">ExpansionGetResults</a>()</div>
<div class="line"><a id="l00115" name="l00115"></a><span class="lineno">  115</span>    {</div>
<div class="line"><a id="l00116" name="l00116"></a><span class="lineno">  116</span>        map&lt;string, ref ExpansionBookCraftingItem&gt; tmp = <span class="keyword">new</span> map&lt;string, ref ExpansionBookCraftingItem&gt;;</div>
<div class="line"><a id="l00117" name="l00117"></a><span class="lineno">  117</span>        <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i &lt; m_NumberOfResults; i++)</div>
<div class="line"><a id="l00118" name="l00118"></a><span class="lineno">  118</span>        {</div>
<div class="line"><a id="l00119" name="l00119"></a><span class="lineno">  119</span>            <span class="keywordtype">string</span> className = m_ItemsToCreate[i];</div>
<div class="line"><a id="l00120" name="l00120"></a><span class="lineno">  120</span>            <span class="keywordtype">string</span> displayName = <span class="stringliteral">&quot;&quot;</span>;</div>
<div class="line"><a id="l00121" name="l00121"></a><span class="lineno">  121</span> </div>
<div class="line"><a id="l00122" name="l00122"></a><span class="lineno">  122</span>            <span class="keywordflow">if</span>( m_ResultInheritsColor[i] != -1 )</div>
<div class="line"><a id="l00123" name="l00123"></a><span class="lineno">  123</span>                className += <span class="stringliteral">&quot;ColorBase&quot;</span>;</div>
<div class="line"><a id="l00124" name="l00124"></a><span class="lineno">  124</span> </div>
<div class="line"><a id="l00125" name="l00125"></a><span class="lineno">  125</span>            displayName = <a class="code hl_class" href="../../db/d6d/a02239.html">ExpansionStatic</a>.<a class="code hl_function" href="../../db/d6d/a02239.html#aafd3d34ac394eb9251cf7ec9a4f3678f">GetItemDisplayNameWithType</a>(className, <a class="code hl_variable" href="../../d3/d95/a01435.html#adfe87c476a9ca142c120bc1af7ea1dbf">m_Expansion_TypeDisplayNames</a>);</div>
<div class="line"><a id="l00126" name="l00126"></a><span class="lineno">  126</span> </div>
<div class="line"><a id="l00127" name="l00127"></a><span class="lineno">  127</span>            <span class="keywordflow">if</span> (!displayName || displayName.IndexOf(<span class="stringliteral">&quot;$UNT$&quot;</span>) == 0)  <span class="comment">//! Skip not ready items</span></div>
<div class="line"><a id="l00128" name="l00128"></a><span class="lineno">  128</span>                <span class="keywordflow">continue</span>;</div>
<div class="line"><a id="l00129" name="l00129"></a><span class="lineno">  129</span> </div>
<div class="line"><a id="l00130" name="l00130"></a><span class="lineno">  130</span>            <span class="keywordtype">int</span> amount = <a class="code hl_function" href="../../d3/d95/a01435.html#a6294384bb75e994c9ed0b40a54efc58b">ExpansionGetAmount</a>(className, m_ResultSetQuantity[i]);</div>
<div class="line"><a id="l00131" name="l00131"></a><span class="lineno">  131</span> </div>
<div class="line"><a id="l00132" name="l00132"></a><span class="lineno">  132</span>            <a class="code hl_class" href="../../d6/d19/a01947.html">ExpansionBookCraftingItem</a> result;</div>
<div class="line"><a id="l00133" name="l00133"></a><span class="lineno">  133</span>            <span class="keywordflow">if</span> (tmp.Find(displayName, result))</div>
<div class="line"><a id="l00134" name="l00134"></a><span class="lineno">  134</span>            {</div>
<div class="line"><a id="l00135" name="l00135"></a><span class="lineno">  135</span>                result.<a class="code hl_variable" href="../../d6/d19/a01947.html#a49d2f2548f5949de27af139d4860fc05">Amount</a> += amount;</div>
<div class="line"><a id="l00136" name="l00136"></a><span class="lineno">  136</span>            }</div>
<div class="line"><a id="l00137" name="l00137"></a><span class="lineno">  137</span>            <span class="keywordflow">else</span></div>
<div class="line"><a id="l00138" name="l00138"></a><span class="lineno">  138</span>            {</div>
<div class="line"><a id="l00139" name="l00139"></a><span class="lineno">  139</span>                result = <span class="keyword">new</span> <a class="code hl_class" href="../../d6/d19/a01947.html">ExpansionBookCraftingItem</a>(displayName, amount);</div>
<div class="line"><a id="l00140" name="l00140"></a><span class="lineno">  140</span>                tmp.Insert(displayName, result);</div>
<div class="line"><a id="l00141" name="l00141"></a><span class="lineno">  141</span>            }</div>
<div class="line"><a id="l00142" name="l00142"></a><span class="lineno">  142</span>            result.<a class="code hl_variable" href="../../d6/d19/a01947.html#ac13cf4ea0ed9041d9736b3834120e570">ClassNames</a>.Insert(className);</div>
<div class="line"><a id="l00143" name="l00143"></a><span class="lineno">  143</span>        }</div>
<div class="line"><a id="l00144" name="l00144"></a><span class="lineno">  144</span> </div>
<div class="line"><a id="l00145" name="l00145"></a><span class="lineno">  145</span>        <span class="keywordflow">return</span> <a class="code hl_function" href="../../d3/d95/a01435.html#a4a2f2889d8052e61d6ea0a3ccf0c10b3">ExpansionGetItems</a>(tmp);</div>
<div class="line"><a id="l00146" name="l00146"></a><span class="lineno">  146</span>    }</div>
<div class="line"><a id="l00147" name="l00147"></a><span class="lineno">  147</span> </div>
<div class="line"><a id="l00148" name="l00148"></a><span class="lineno"><a class="line" href="../../d3/d95/a01435.html#a6294384bb75e994c9ed0b40a54efc58b">  148</a></span>    <span class="keyword">protected</span> <span class="keyword">static</span> <span class="keywordtype">int</span> <a class="code hl_function" href="../../d3/d95/a01435.html#a6294384bb75e994c9ed0b40a54efc58b">ExpansionGetAmount</a>(<span class="keywordtype">string</span> className, <span class="keywordtype">int</span> quantity)</div>
<div class="line"><a id="l00149" name="l00149"></a><span class="lineno">  149</span>    {</div>
<div class="line"><a id="l00150" name="l00150"></a><span class="lineno">  150</span>        <span class="keywordflow">if</span> (quantity != -1)</div>
<div class="line"><a id="l00151" name="l00151"></a><span class="lineno">  151</span>        {</div>
<div class="line"><a id="l00152" name="l00152"></a><span class="lineno">  152</span>            TStringArray cfgSearches = {CFG_VEHICLESPATH, CFG_MAGAZINESPATH};</div>
<div class="line"><a id="l00153" name="l00153"></a><span class="lineno">  153</span>            <span class="keywordflow">foreach</span> (<span class="keywordtype">string</span> cfgSearch : cfgSearches)</div>
<div class="line"><a id="l00154" name="l00154"></a><span class="lineno">  154</span>            {<span class="comment"></span></div>
<div class="line"><a id="l00155" name="l00155"></a><span class="lineno">  155</span><span class="comment">                //! Only set amount if item can be split</span></div>
<div class="line"><a id="l00156" name="l00156"></a><span class="lineno">  156</span><span class="comment"></span>                <span class="keywordtype">string</span> cfgPath = cfgSearch + <span class="stringliteral">&quot; &quot;</span> + className + <span class="stringliteral">&quot; canBeSplit&quot;</span>;</div>
<div class="line"><a id="l00157" name="l00157"></a><span class="lineno">  157</span>                <span class="keywordflow">if</span> (GetGame().ConfigIsExisting(cfgPath) &amp;&amp; GetGame().ConfigGetInt(cfgPath))</div>
<div class="line"><a id="l00158" name="l00158"></a><span class="lineno">  158</span>                {</div>
<div class="line"><a id="l00159" name="l00159"></a><span class="lineno">  159</span>                    <span class="keywordflow">return</span> quantity;</div>
<div class="line"><a id="l00160" name="l00160"></a><span class="lineno">  160</span>                }</div>
<div class="line"><a id="l00161" name="l00161"></a><span class="lineno">  161</span>            }</div>
<div class="line"><a id="l00162" name="l00162"></a><span class="lineno">  162</span>        }</div>
<div class="line"><a id="l00163" name="l00163"></a><span class="lineno">  163</span> </div>
<div class="line"><a id="l00164" name="l00164"></a><span class="lineno">  164</span>        <span class="keywordflow">return</span> 1;</div>
<div class="line"><a id="l00165" name="l00165"></a><span class="lineno">  165</span>    }</div>
<div class="line"><a id="l00166" name="l00166"></a><span class="lineno">  166</span> </div>
<div class="line"><a id="l00167" name="l00167"></a><span class="lineno"><a class="line" href="../../d3/d95/a01435.html#a4a2f2889d8052e61d6ea0a3ccf0c10b3">  167</a></span>    array&lt;ref ExpansionBookCraftingItem&gt; <a class="code hl_function" href="../../d3/d95/a01435.html#a4a2f2889d8052e61d6ea0a3ccf0c10b3">ExpansionGetItems</a>(map&lt;string, ref ExpansionBookCraftingItem&gt; tmp)</div>
<div class="line"><a id="l00168" name="l00168"></a><span class="lineno">  168</span>    {</div>
<div class="line"><a id="l00169" name="l00169"></a><span class="lineno">  169</span>        array&lt;ref ExpansionBookCraftingItem&gt; items = <span class="keyword">new</span> array&lt;ref ExpansionBookCraftingItem&gt;;</div>
<div class="line"><a id="l00170" name="l00170"></a><span class="lineno">  170</span>        <span class="keywordflow">foreach</span> (<span class="keywordtype">string</span> displayName, <a class="code hl_class" href="../../d6/d19/a01947.html">ExpansionBookCraftingItem</a> item: tmp)</div>
<div class="line"><a id="l00171" name="l00171"></a><span class="lineno">  171</span>        {</div>
<div class="line"><a id="l00172" name="l00172"></a><span class="lineno">  172</span>            items.Insert(item);</div>
<div class="line"><a id="l00173" name="l00173"></a><span class="lineno">  173</span>        }</div>
<div class="line"><a id="l00174" name="l00174"></a><span class="lineno">  174</span>        <span class="keywordflow">return</span> items;</div>
<div class="line"><a id="l00175" name="l00175"></a><span class="lineno">  175</span>    }</div>
<div class="line"><a id="l00176" name="l00176"></a><span class="lineno">  176</span>}</div>
<div class="ttc" id="aa01435_html"><div class="ttname"><a href="../../d3/d95/a01435.html">RecipeBase</a></div><div class="ttdef"><b>Definition:</b> <a href="../../da/dec/a00080_source.html#l00013">craftterritoryflagkit.c:14</a></div></div>
<div class="ttc" id="aa01435_html_a4a2f2889d8052e61d6ea0a3ccf0c10b3"><div class="ttname"><a href="../../d3/d95/a01435.html#a4a2f2889d8052e61d6ea0a3ccf0c10b3">RecipeBase::ExpansionGetItems</a></div><div class="ttdeci">array&lt; ref ExpansionBookCraftingItem &gt; ExpansionGetItems(map&lt; string, ref ExpansionBookCraftingItem &gt; tmp)</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/df0/a00557_source.html#l00167">recipebase.c:167</a></div></div>
<div class="ttc" id="aa01435_html_a6294384bb75e994c9ed0b40a54efc58b"><div class="ttname"><a href="../../d3/d95/a01435.html#a6294384bb75e994c9ed0b40a54efc58b">RecipeBase::ExpansionGetAmount</a></div><div class="ttdeci">static protected int ExpansionGetAmount(string className, int quantity)</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/df0/a00557_source.html#l00148">recipebase.c:148</a></div></div>
<div class="ttc" id="aa01435_html_a83472400848cd2193dc62a96249aa7bb"><div class="ttname"><a href="../../d3/d95/a01435.html#a83472400848cd2193dc62a96249aa7bb">RecipeBase::ExpansionGetIngredients</a></div><div class="ttdeci">array&lt; ref array&lt; ref ExpansionBookCraftingItem &gt; &gt; ExpansionGetIngredients()</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/df0/a00557_source.html#l00017">recipebase.c:17</a></div></div>
<div class="ttc" id="aa01435_html_a8c2b9eb21d7207f1880b4b9f8e10b1d0"><div class="ttname"><a href="../../d3/d95/a01435.html#a8c2b9eb21d7207f1880b4b9f8e10b1d0">RecipeBase::ExpansionGetResults</a></div><div class="ttdeci">array&lt; ref ExpansionBookCraftingItem &gt; ExpansionGetResults()</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/df0/a00557_source.html#l00114">recipebase.c:114</a></div></div>
<div class="ttc" id="aa01435_html_adfe87c476a9ca142c120bc1af7ea1dbf"><div class="ttname"><a href="../../d3/d95/a01435.html#adfe87c476a9ca142c120bc1af7ea1dbf">RecipeBase::m_Expansion_TypeDisplayNames</a></div><div class="ttdeci">static protected ref map&lt; string, string &gt; m_Expansion_TypeDisplayNames</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/df0/a00557_source.html#l00015">recipebase.c:15</a></div></div>
<div class="ttc" id="aa01947_html"><div class="ttname"><a href="../../d6/d19/a01947.html">ExpansionBookCraftingItem</a></div><div class="ttdef"><b>Definition:</b> <a href="../../dc/df9/a00554_source.html#l00278">expansionbookcraftingcategoryrecipes.c:279</a></div></div>
<div class="ttc" id="aa01947_html_a49d2f2548f5949de27af139d4860fc05"><div class="ttname"><a href="../../d6/d19/a01947.html#a49d2f2548f5949de27af139d4860fc05">ExpansionBookCraftingItem::Amount</a></div><div class="ttdeci">int Amount</div><div class="ttdef"><b>Definition:</b> <a href="../../dc/df9/a00554_source.html#l00281">expansionbookcraftingcategoryrecipes.c:281</a></div></div>
<div class="ttc" id="aa01947_html_ac13cf4ea0ed9041d9736b3834120e570"><div class="ttname"><a href="../../d6/d19/a01947.html#ac13cf4ea0ed9041d9736b3834120e570">ExpansionBookCraftingItem::ClassNames</a></div><div class="ttdeci">autoptr TStringArray ClassNames</div><div class="ttdef"><b>Definition:</b> <a href="../../dc/df9/a00554_source.html#l00282">expansionbookcraftingcategoryrecipes.c:282</a></div></div>
<div class="ttc" id="aa02239_html"><div class="ttname"><a href="../../db/d6d/a02239.html">ExpansionStatic</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d72/a00803_source.html#l00074">expansionstatic.c:75</a></div></div>
<div class="ttc" id="aa02239_html_aafd3d34ac394eb9251cf7ec9a4f3678f"><div class="ttname"><a href="../../db/d6d/a02239.html#aafd3d34ac394eb9251cf7ec9a4f3678f">ExpansionStatic::GetItemDisplayNameWithType</a></div><div class="ttdeci">static string GetItemDisplayNameWithType(string type_name, map&lt; string, string &gt; cache=NULL)</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d72/a00803_source.html#l00165">expansionstatic.c:165</a></div></div>
<div class="ttc" id="aa02239_html_af02af7eca0824d4329ade05587d8a9ac"><div class="ttname"><a href="../../db/d6d/a02239.html#af02af7eca0824d4329ade05587d8a9ac">ExpansionStatic::ItemExists</a></div><div class="ttdeci">static bool ItemExists(string type_name)</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d72/a00803_source.html#l00299">expansionstatic.c:299</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="../../dir_6127fff2da0a20e2dc2cd9302c584350.html">DayzExpansion</a></li><li class="navelem"><a class="el" href="../../dir_962bfa1893272c9ca8d900ccfa6a09f5.html">Book</a></li><li class="navelem"><a class="el" href="../../dir_5f6b997996f72d4bae47b189b5fbd491.html">Scripts</a></li><li class="navelem"><a class="el" href="../../dir_7bf89cc13cab6aae2e93239962874a6d.html">4_world</a></li><li class="navelem"><a class="el" href="../../dir_fa5e500ddafd5d7c04b93352737ee725.html">dayzexpansion_book</a></li><li class="navelem"><a class="el" href="../../dir_9db33dfb44715fe21a4a4bee27ac0054.html">classes</a></li><li class="navelem"><a class="el" href="../../dir_0dc64200b77300758e867b99d6d6e52e.html">recipes</a></li><li class="navelem"><a class="el" href="../../d8/df0/a00557.html">recipebase.c</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="../../doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.5 </li>
  </ul>
</div>
</body>
</html>
